//
//  checksum.c
//  FF6Tools
//
//  Created by Evan Owen on 2/19/15.
//
//

#include "checksum.h"
#include <stdlib.h>

unsigned short checksum_calc_sum (const unsigned char* data, size_t length)
{
    unsigned short sum = 0;
    
    for (unsigned int i = 0; i < length; i++)
        sum += data[i];
    
    return (sum);
}

unsigned short checksum_mirror_sum (const unsigned char* start, size_t length, size_t mask)
{
    // from NSRT
    while (!(length & mask))
        mask >>= 1;
    
    unsigned short part1 = checksum_calc_sum(start, mask);
    unsigned short part2 = 0;
    
    size_t next_length = length - mask;
    if (next_length)
    {
        part2 = checksum_mirror_sum(start + mask, next_length, mask >> 1);
        
        while (next_length < mask)
        {
            next_length += next_length;
            part2 += part2;
        }
    }
    
    return (part1 + part2);
}

unsigned short calculate_checksum(const unsigned char* data, size_t length)
{
    return checksum_mirror_sum(data, length, 0x800000);
}
