//
//  TrainScript.swift
//  FF6Tools
//
//  Created by Evan Owen on 4/26/17.
//
//

import Foundation

class TrainScriptEncoding: ROMScriptEncoding {
    
    override func descriptionForCommand(_ command: ROMCommand) -> String {
        
        switch command.intValue(forKey: "command") {

        case 0:
            var commandDescription = ""
            switch command.intValue(forKey: "pitch") {
            case 0: commandDescription = "0 0 0"
            case 1: commandDescription = "0 ↑ 0"
            case 2: commandDescription = "0 ↓ 0"
            case 3: commandDescription = "0 ↑ ↑"
            case 4: commandDescription = "↓ ↓ 0"
            case 5: commandDescription = "↑ ↑ ↑"
            case 6: commandDescription = "↓ ↓ ↓"
            case 7: commandDescription = "↑ ↑ 0"
            case 8: commandDescription = "0 ↓ ↓"
            case 9: commandDescription = "0 - ↑"
            case 10: commandDescription = "↑ - 0"
            case 11: commandDescription = "0 - ↓"
            case 12: commandDescription = "↓ - 0"
            default: break
            }

            switch command.intValue(forKey: "yaw") {
            case 1: commandDescription += ", Left Turn"
            case 2: commandDescription += ", Right Turn"
            default: break
            }

            switch command.intValue(forKey: "background") {
            case 0: commandDescription += ", Pipes (more beams)"
            case 1: commandDescription += ", Pipes (fewer beams)"
            case 2: commandDescription += ", No Pipes"
            case 3: commandDescription += ", Split Track (more walls)"
            case 4: commandDescription += ", Split Track (fewer walls)"
            default: break
            }
            return commandDescription

        case 0x01..<0x40:
            return "Conditional Branch"

        case 0x40..<0x80:
            return "Branch"

        case 0x80..<0xA0:
            return "Rotate"

        case 0xA0..<0xC0:
            return "Rotate"

        case 0xE0:
            return "Battle 1"

        case 0xE1:
            return "Battle 2"

        case 0xE2:
            return "Boss Battle"

        case 0xFF:
            return "End of Script"

        default:
            return super.descriptionForCommand(command)
        }
    }
}
